import java.rmi.*;

public class CallbackHelloClient {
    public static void main(String args[]) {
        try {
			/* ricerca il callback server */
            System.out.println("### Lookup CallbackHelloServer");
	        String registryUrl = "rmi://localhost/CallbackHelloServer";
            CallbackHelloServerInterface h =
            	(CallbackHelloServerInterface) Naming.lookup(registryUrl);
            System.out.println("### Lookup CallbackHelloServer complete");

            /* si registra per il callback */
            System.out.println("### Registering for callback");
            CallbackHelloClientInterface callbackObj = new CallbackHelloClientImpl();
            h.registerForCallback(callbackObj);
            System.out.println("### Registering for callback complete");

            /* accesso al server - fa una serie casuale di 5-15 richieste */
            int n = (int) (Math.random()*10+5); 
            for (int i=0; i<n; i++) {
            	String message = h.sayHello("io faccio " + n + " richieste");
            	System.out.println("### HelloClient: " + message);
                Thread.sleep(1500);
            }

            /* cancella la registrazione per il callback */
            System.out.println("### Unregistering for callback");
            h.unregisterForCallback(callbackObj);
            System.out.println("### Unregistering for callback complete");
            System.exit(0);
        } catch (Exception e) {
            System.err.println("### HelloClient exception: " +
                               e.getMessage());
            // e.printStackTrace();
        }
    }
}

